cmake_minimum_required(VERSION 3.26)
project(BLT_With_Graphics_Template)

option(ENABLE_ADDRSAN "Enable the address sanitizer" OFF)
option(ENABLE_UBSAN "Enable the ub sanitizer" OFF)
option(ENABLE_TSAN "Enable the thread data race sanitizer" OFF)

set(CMAKE_CXX_STANDARD 17)
set(GLFW_BUILD_DOCS OFF CACHE BOOL "" FORCE)
set(GLFW_BUILD_TESTS OFF CACHE BOOL "" FORCE)
set(GLFW_BUILD_EXAMPLES OFF CACHE BOOL "" FORCE)

add_subdirectory(libraries/BLT)
add_subdirectory(libraries/glfw-3.3.8)


include_directories(include/)
file(GLOB_RECURSE PROJECT_BUILD_FILES "${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp")

add_executable(BLT_With_Graphics_Template ${PROJECT_BUILD_FILES})

target_link_libraries(BLT_With_Graphics_Template glfw)
target_link_libraries(BLT_With_Graphics_Template BLT)

target_compile_options(BLT_With_Graphics_Template PRIVATE -Wall -Werror -Wpedantic -Wno-comment)
target_link_options(BLT_With_Graphics_Template PRIVATE -Wall -Werror -Wpedantic -Wno-comment)

if (${ENABLE_ADDRSAN} MATCHES ON)
    target_compile_options(BLT_With_Graphics_Template PRIVATE -fsanitize=address)
    target_link_options(BLT_With_Graphics_Template PRIVATE -fsanitize=address)
endif ()

if (${ENABLE_UBSAN} MATCHES ON)
    target_compile_options(BLT_With_Graphics_Template PRIVATE -fsanitize=undefined)
    target_link_options(BLT_With_Graphics_Template PRIVATE -fsanitize=undefined)
endif ()

if (${ENABLE_TSAN} MATCHES ON)
    target_compile_options(BLT_With_Graphics_Template PRIVATE -fsanitize=thread)
    target_link_options(BLT_With_Graphics_Template PRIVATE -fsanitize=thread)
endif ()